import 'dart:async';
import 'dart:io';
import 'dart:json';
import 'json_database.dart';

void main() {
  HttpServer.bind(InternetAddress.LOOPBACK_IP_V4, 8080).then(
    (HttpServer server) {
      server.listen(
          (HttpRequest request) {
            switch (request.method) {
              case "GET":
                addCorsHeaders(request.response);
                
                request.response.headers.add(HttpHeaders.CONTENT_TYPE, "application/json");
                
                getJSON(request.uri.queryParameters).then(
                  (String result) {
                    request.response.write(result);
                    request.response.close();
                  }
                );
                
                break;
              case "POST":
                break;
              case "OPTIONS":
                break;
            }
           }
      );
    }
  );
}

Future<String> getJSON(Map<String, String> queryParameters) {
  Completer completer = new Completer();
  JsonDatabase dbo = new JsonDatabase();
  
  dbo.ormEntityLoad(queryParameters['entityName']).then(
      (List<Map<String, dynamic>> result) => completer.complete(stringify(result))
  );
  
  return completer.future;
}

void addCorsHeaders(HttpResponse res) {
  res.headers.add("Access-Control-Allow-Origin", "*, ");
  res.headers.add("Access-Control-Allow-Methods", "POST, GET, OPTIONS");
  res.headers.add("Access-Control-Allow-Headers", "Origin, X-Requested-With, Content-Type, Accept");
}